function M = fdetect_a1(I,n, MaxFaceNum)
% FDETECT_A1 Face Detection Average Face Approach 1

load('av_face');
[ImgHeight, ImgWidth] = size(I);
[AvHeight, AvWidth] = size(av_face);
AvPixels = AvHeight * AvWidth;

if( n < 1 )
   BlkWidth = round(ImgWidth * n);
else
   BlkWidth = n;
end

Small = double(imresize(I, AvWidth/BlkWidth, 'nearest'));
av_face = double(av_face);
av_face = av_face - mean(mean(av_face));

[Height, Width] = size(Small);
xEnd = Width-AvWidth;
yEnd = Height-AvHeight;
yStep = AvHeight - 1;
xStep = AvWidth - 1;
for y=1:yEnd
   for x=1:xEnd
      Region = Small(y:y+yStep,x:x+xStep);
      Region = Region - mean(mean(Region));
      Temp = Region - av_face;
      %Temp = Small(y:y+yStep,x:x+xStep) - av_face;
      MeanSquareError(y,x) = sum(sum(Temp .* Temp))/AvPixels;
   end
end

%Max = max(max(MeanSquareError));
%imshow(uint8(MeanSquareError*255/Max));
Temp = 0 - MeanSquareError;
[mValue, mY, mX] = maxn(Temp, MaxFaceNum, [-65536, 0]);

Ratio = BlkWidth/AvWidth;
HalfRatio = Ratio/2;
k = 1;
for i=1:length(mValue)
   ltx(k) = floor(mX(i)*Ratio - HalfRatio);
   lty(k) = floor(mY(i)*Ratio - HalfRatio);
   rbx(k) = ltx(k) + BlkWidth;
   rby(k) = lty(k) + BlkWidth;
   if( ltx(k)<1 | lty(k)<1 | rbx(k)>ImgWidth | rby(k)>ImgHeight )
      ltx(k) = []; lty(k) = []; rbx(k) = []; rby(k) = [];
   else
      k = k+1;
   end
end
M = imrect(I, ltx,lty,rbx,rby);