function M = fdetect_h(I)
% FDETECT_H face detection hiararchical

NoF = 20;   % Number of posible face in the Image
Ratio = 0.89;

[Height, Width] = size(I);
MinFaceSize = Width / 10;
if(MinFaceSize<20)
   MinFaceSize = 20;
end
MaxFaceSize = Width / 2;

MinFaceSize = 100;
MaxFaceSize = 200;

ellip = imread('ellip.bmp');
ellipx = gradx(ellip);
ellipy = grady(ellip);

FaceSize = MinFaceSize;
temp = 20/MinFaceSize;
pN = 1;
while(FaceSize <= MaxFaceSize)
   fprintf(1, 'Detect Face Size: %d\n', floor(FaceSize) );
   SmallImage = imresize(I, temp);
   
   % Detection
   Rx = conv2(gradx(SmallImage),ellipx, 'same');
   Ry = conv2(grady(SmallImage),ellipy, 'same');
   R = Rx + Ry;
   pEnd = pN+NoF-1;
   [pV(pN:pEnd), pY(pN:pEnd), pX(pN:pEnd)] = maxn(R, NoF, 0);
   pY(pN:pEnd) = pY(pN:pEnd) / temp;
   pX(pN:pEnd) = pX(pN:pEnd) / temp;
   pSize(pN:pEnd) = FaceSize;
   pN = pEnd + 1;
   
   temp = temp * Ratio;
   FaceSize = 20/temp;
end

[Value, Y, X] = maxn(pV, NoF, 0);

k = 1;
for i=1:NoF
   CenterX = pX(X(i));
   CenterY = pY(X(i));
   HalfWidth = pSize(X(i)) / 2;
   HalfHeight = HalfWidth * 1.2;
   ltx(k) = floor(CenterX - HalfWidth);
   lty(k) = floor(CenterY - HalfHeight);
   rbx(k) = floor(CenterX + HalfWidth);
   rby(k) = floor(CenterY + HalfHeight);
   if( ltx(k) < 1 | lty(k) < 1 | rbx(k) > Width | rby(k) > Height )
      ltx(k) = [];
      lty(k) = [];
      rbx(k) = [];
      rby(k) = [];
   else
      k = k+1;
   end
end

M = imrect(I,ltx,lty,rbx,rby);
imshow(M);
