function M = fdetect_h(I)
% FDETECT_H face detection hiararchical

AverageT = 400;
Dx = [-1 -2 -1; 0 0 0; 1 2 1];
Dy = [-1 0 1; -2 0 2; -1 0 1];

NoF = 20;   % Number of posible face in the Image
Ratio = 0.89;

[Height, Width] = size(I);
MinFaceSize = Width / 10;
if(MinFaceSize<20)
   MinFaceSize = 20;
end
MaxFaceSize = Width / 2;

MaxFaceSize = 200;
MinFaceSize = 100;

ellip = double(imread('ellip.bmp'));
ellipx = abs(conv2(ellip, Dx, 'valid'));
ellipy = abs(conv2(ellip, Dy, 'valid'));
ellipx = ellipx .* 255 ./ max(max(ellipx));
ellipy = ellipy .* 255 ./ max(max(ellipy));

FaceSize = MinFaceSize;
temp = 20/MinFaceSize;
pN = 1;
while(FaceSize <= MaxFaceSize)
   fprintf(1, 'Detect Face Size: %d\n', floor(FaceSize) );
   SmallImage = imresize(I, temp);
   % Detection
   Gx = abs(conv2(SmallImage, Dx, 'valid'));
   Gx = Gx .* 255 ./ max(max(Gx));
   Gy = abs(conv2(SmallImage, Dy, 'valid'));
   Gy = Gy .* 255 ./ max(max(Gy));
   imshow( uint8( (Gx+Gy) /2));
   input('pause');
   Rx = conv2(Gx, ellipx, 'same');
   Ry = conv2(Gy, ellipy, 'same');
   R = Rx + Ry;
   %Average = conv2(Gx+Gy, ellip, 'same');
   
   %[Height, Width] = size(R);
   
   %for i=1:Height
   %   for j=1:Width
   %      if Average(i,j) < AverageT
   %         R(i,j) = 0;
   %      else
   %         R(i,j) = (Rx(i,j) + Ry(i,j)) / Average(i,j);
   %      end
   %   end
   %end
   
   imshow(uint8(R * 255 / max(max(R))));
   
   pEnd = pN+NoF-1;
   [pV(pN:pEnd), pY(pN:pEnd), pX(pN:pEnd)] = maxn(R, NoF, 0);
   pY(pN:pEnd) = pY(pN:pEnd) / temp;
   pX(pN:pEnd) = pX(pN:pEnd) / temp;
   pSize(pN:pEnd) = FaceSize;
   pN = pEnd + 1;
   
   temp = temp * Ratio;
   FaceSize = 20/temp;
end

[Value, Y, X] = maxn(pV, NoF, 0);

k = 1;
for i=1:NoF
   CenterX = pX(X(i));
   CenterY = pY(X(i));
   HalfWidth = pSize(X(i)) / 2;
   HalfHeight = HalfWidth * 1.2;
   ltx(k) = floor(CenterX - HalfWidth);
   lty(k) = floor(CenterY - HalfHeight);
   rbx(k) = floor(CenterX + HalfWidth);
   rby(k) = floor(CenterY + HalfHeight);
   if( ltx(k) < 1 | lty(k) < 1 | rbx(k) > Width | rby(k) > Height )
      ltx(k) = [];
      lty(k) = [];
      rbx(k) = [];
      rby(k) = [];
   else
      k = k+1;
   end
end

M = imrect(I,ltx,lty,rbx,rby);
imshow(M);