function M = fdetect_n(I,n,Net)
% FDETECT3 face detection approach 3

[ImgHeight, ImgWidth] = size(I);
Net.threshold = 0.9;

if( n < 1 )
   FaceWidth = round(ImgWidth * n);
else
   FaceWidth = n;
end

BlkWidth = 20;
BlkHeight = 23;
StepLength = floor(BlkWidth / 10);

TempI = double(imresize(I,BlkWidth/FaceWidth,'nearest'));

PossibleNum = 0;

[Height, Width] = size(TempI);
for x=1:2:(Width-BlkWidth)
   for y=1:2:(Height-BlkHeight)
      % [x,y]
      % input('wait!');
      % subplot(1,2,1),subimage(imrect(I, x, y, x+BlkWidth, y+BlkWidth));
      Small = TempI(y:y+BlkHeight,x:x+BlkWidth);
      % subplot(1,2,2),subimage( imresize(uint8(I4x4), [128,128], 'nearest'));
      % input('wait!');
      k=1;
      for i=1:20
         for j=1:23
            Vector(k,1) = Small(j,i);
            k = k+1;
         end
      end
      if( strcmp(Net.mode, 'std') )
         Vector = trastd(Vector, Net.mean, Net.std);
      elseif( strcmp(Net.mode, 'pca') )
         Vector = trastd(Vector, Net.mean, Net.std);
         Vector = trapca(Vector, Net.transMat);
      end
      IsFace = sim(Net.net, Vector);
      if(IsFace > Net.threshold)
         PossibleNum = PossibleNum + 1;
         Possible(PossibleNum,1) = y;
         Possible(PossibleNum,2) = x;
      end
   end
end

Ratio = FaceWidth/BlkWidth;
HalfRatio = Ratio/2;
k=1;
for i=1:length(Possible)
   ltx(k) = floor(Possible(i,2)*Ratio - HalfRatio);
   lty(k) = floor(Possible(i,1)*Ratio - HalfRatio);
   rbx(k) = ltx(k) + FaceWidth;
   rby(k) = lty(k) + FaceWidth;
   if( ltx(k)<1 | lty(k)<1 | rbx(k)>ImgWidth | rby(k)>ImgHeight )
      ltx(k) = []; lty(k) = []; rbx(k) = []; rby(k) = [];
   else
      k = k+1;
   end
end
if(PossibleNum > 0)
   M = imrect(I, ltx,lty,rbx,rby);
else
   M = I;
end
imshow(M);