function M = fdetect_n(I,n,Net)
% FDETECT3 face detection approach 3

[ImgHeight, ImgWidth] = size(I);
Net.threshold = 0.9;

load('av_face');
av_face = double(av_face);

if( n < 1 )
   FaceWidth = round(ImgWidth * n);
else
   FaceWidth = n;
end

BlkWidth = 20;
BlkHeight = 23;
StepLength = floor(BlkWidth / 10);

TempI = double(imresize(I,BlkWidth/FaceWidth,'nearest'));

PossibleNum = 0;

[Height, Width] = size(TempI);
for x=1:2:(Width-BlkWidth)
   for y=1:2:(Height-BlkHeight)
      % [x,y]
      % input('wait!');
      % subplot(1,2,1),subimage(imrect(I, x, y, x+BlkWidth, y+BlkWidth));
      Small = TempI(y:y+BlkHeight,x:x+BlkWidth);
      % subplot(1,2,2),subimage( imresize(uint8(I4x4), [128,128], 'nearest'));
      % input('wait!');
      k=1;
      for i=1:20
         for j=1:23
            Vector(k,1) = Small(j,i);
            k = k+1;
         end
      end
      if( strcmp(Net.mode, 'std') )
         Vector = trastd(Vector, Net.mean, Net.std);
      elseif( strcmp(Net.mode, 'pca') )
         Vector = trastd(Vector, Net.mean, Net.std);
         Vector = trapca(Vector, Net.transMat);
      end
      IsFace = sim(Net.net, Vector);
      if(IsFace > Net.threshold)
         PossibleNum = PossibleNum + 1;
         Possible(PossibleNum,1) = y;
         Possible(PossibleNum,2) = x;
      end
   end
end

for i=1:PossibleNum
   I8x8 = To8x8(I,y,x,BlkWidth);
   % Eye Rule
   EyePosition = [];
   EyeNum = 0;
   for v_lineNum=2:7
      v_line = I8x8(:,v_lineNum);
      for pixel=3:6
         if(v_line(pixel) < v_line(pixel-1) & v_line(pixel) < v_line(pixel+1))
            if( (v_line(pixel-1)-v_line(pixel)) > EyeGrayDiff | (v_line(pixel+1)-v_line(pixel)) > EyeGrayDiff )
               EyeNum = EyeNum + 1;
               EyePosition(EyeNum,1) = pixel;
               EyePosition(EyeNum,2) = v_lineNum;
            end
         end
      end
   end
   if EyePosition 
      PairPosition = [];
      PairNum = 0;
      NumOnHLine = 0;
      for e1=1:EyeNum-1
         EyeP1y = EyePosition(e1,1);
         EyeP1x = EyePosition(e1,2);
         for e2=e1+1:EyeNum
            EyeP2y = EyePosition(e2,1);
            EyeP2x = EyePosition(e2,2);
            if(abs(EyeP2y-EyeP1y) <=1 & abs(EyeP2x - EyeP1x) > 2 & abs(EyeP2x - EyeP1x) < 5)
               PairNum = PairNum + 1;
               PairPosition(PairNum, 1) = EyeP1y;
               PairPosition(PairNum, 2) = EyeP1x;
               PairPosition(PairNum, 3) = EyeP2y;
               PairPosition(PairNum, 4) = EyeP2x;
            end
         end
      end
      if PairPosition & PairNum < 6
         fprintf(1, 'PairNum=%d\n', PairNum);
         Ratio = BlkWidth/8;
         HalfRatio = Ratio/2;
         for i=1:PairNum
            PairPosition(i,1) = PairPosition(i,1)*Ratio + y - HalfRatio;
            PairPosition(i,2) = PairPosition(i,2)*Ratio + x - HalfRatio;
            PairPosition(i,3) = PairPosition(i,3)*Ratio + y - HalfRatio;
            PairPosition(i,4) = PairPosition(i,4)*Ratio + x - HalfRatio;
            for j=1:4
               fprintf(1, '  %d', PairPosition(i,j));
            end
            fprintf(1, '  (x,y)=(%d,%d)\n', x,y);
         end
         EyePair(EyePairNum+1:EyePairNum+PairNum,:) = PairPosition(:,:);
         EyePairNum = EyePairNum + PairNum;
               
         PossibleNum = PossibleNum + 1;
         Possible(PossibleNum, 1) = y;
         Possible(PossibleNum, 2) = x;
      end
   end
end

Ratio = FaceWidth/BlkWidth;
HalfRatio = Ratio/2;
k=1;
for i=1:length(Possible)
   ltx(k) = floor(Possible(i,2)*Ratio - HalfRatio);
   lty(k) = floor(Possible(i,1)*Ratio - HalfRatio);
   rbx(k) = ltx(k) + FaceWidth;
   rby(k) = lty(k) + FaceWidth;
   if( ltx(k)<1 | lty(k)<1 | rbx(k)>ImgWidth | rby(k)>ImgHeight )
      ltx(k) = []; lty(k) = []; rbx(k) = []; rby(k) = [];
   else
      k = k+1;
   end
end
if(PossibleNum > 0)
   M = imrect(I, ltx,lty,rbx,rby);
else
   M = I;
end
imshow(M);