static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: maxn 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/***************** Compiler Assumptions ****************
 *
 *       B0_         	boolean scalar temporary
 *       Height      	integer scalar
 *       I           	complex vector/matrix
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       I2_         	integer scalar temporary
 *       IM0_        	integer vector/matrix temporary
 *       RM0_        	real vector/matrix temporary
 *       Range       	complex vector/matrix
 *       Value       	complex scalar
 *       Width       	integer scalar
 *       i           	integer scalar
 *       j           	integer scalar
 *       k           	integer scalar
 *       m           	real scalar
 *       maxn        	<function being defined>
 *       mvalue      	complex vector/matrix
 *       n           	real scalar
 *       size        	<function>
 *       x           	integer vector/matrix
 *       y           	integer vector/matrix
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   int ci_;
   int i_;
   

   if (nrhs_ > 3 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 3 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   for (ci_=i_=0; i_<nrhs_; ++i_)
   {
      if ( mccPI(prhs_[i_]) )
      {
         ci_ = 1;
         break;
      }
   }
   if (ci_)
   {
      mxArray mvalue;
      mxArray y;
      mxArray x;
      mxArray I;
      double n = 0.0;
      int n_set_ = 0;
      mxArray Range;
      int Height = 0;
      int Width = 0;
      int i = 0;
      int j = 0;
      double Value_r=0.0, Value_i=0.0;
      int k = 0;
      double m = 0.0;
      mxArray IM0_;
      int I0_ = 0;
      int I1_ = 0;
      unsigned short B0_ = 0;
      int I2_ = 0;
      mxArray RM0_;
      
      mccComplexInit(I);
      mccImport(&I, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      n = mccImportReal(&n_set_, 0, (mxArray *) ((nrhs_>1) ? prhs_[1] : 0), 0, "n");
      mccComplexInit(Range);
      mccImport(&Range, ((nrhs_>2) ? prhs_[2] : 0), 0, 0);
      mccComplexInit(mvalue);
      mccIntInit(y);
      mccIntInit(x);
      mccIntInit(IM0_);
      mccRealInit(RM0_);
      
      /* % MAXN the max n position */
      
      /* [Height, Width] = size(I); */
      if(mccNOTSET(&I))
      {
         mexErrMsgTxt( "variable I undefined, line 4" );
      }
      mccGetMatrixSize(&Height,&Width, &I);
      
      /* mvalue(1:n) = Range(1)-1; */
      if(mccNOTSET(&Range))
      {
         mexErrMsgTxt( "variable Range undefined, line 6" );
      }
      if( !n_set_ )
      {
         mexErrMsgTxt( "variable n undefined, line 6" );
      }
      mccColon2(&IM0_, (double)1, n);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_mvalue;
         double *q_mvalue;
         int *p_IM0_;
         int I_IM0_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &mvalue);
         mccGrowVector(&mvalue, mccGetMaxIndex(&IM0_ ,mccM(&mvalue)*mccN(&mvalue)));
         I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
         p_IM0_ = mccIPR(&IM0_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_IM0_+=I_IM0_)
               {
                  mccSetVectorElement(&mvalue, mccRint(((int)*p_IM0_)), ((mccGetRealVectorElement(&Range, mccRint(1))) - 1), (mccGetImagVectorElement(&Range, mccRint(1)) - 0.));
               }
            }
         }
      }
      mccLOG(&mvalue) = 0;
      mccSTRING(&mvalue) = 0;
      /* y(1:n) = 0; */
      mccColon2(&IM0_, (double)1, n);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         int *p_y;
         int *p_IM0_;
         int I_IM0_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &y);
         mccGrowVector(&y, mccGetMaxIndex(&IM0_ ,mccM(&y)*mccN(&y)));
         I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
         p_IM0_ = mccIPR(&IM0_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_IM0_+=I_IM0_)
               {
                  mccSetIntVectorElement(&y, mccRint(((int)*p_IM0_)), (double)0);
               }
            }
         }
      }
      mccLOG(&y) = 0;
      mccSTRING(&y) = 0;
      /* x(1:n) = 0; */
      mccColon2(&IM0_, (double)1, n);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         int *p_x;
         int *p_IM0_;
         int I_IM0_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &x);
         mccGrowVector(&x, mccGetMaxIndex(&IM0_ ,mccM(&x)*mccN(&x)));
         I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
         p_IM0_ = mccIPR(&IM0_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_IM0_+=I_IM0_)
               {
                  mccSetIntVectorElement(&x, mccRint(((int)*p_IM0_)), (double)0);
               }
            }
         }
      }
      mccLOG(&x) = 0;
      mccSTRING(&x) = 0;
      
      /* for i=1:Height */
      for (I0_ = 1; I0_ <= Height; I0_ = I0_ + 1)
      {
         i = I0_;
         /* for j=1:Width */
         for (I1_ = 1; I1_ <= Width; I1_ = I1_ + 1)
         {
            j = I1_;
            /* Value = I(i,j); */
            Value_r = (mccGetRealMatrixElement(&I, mccRint(i), mccRint(j)));
            Value_i = mccGetImagMatrixElement(&I, mccRint(i), mccRint(j));
            /* k = 1; */
            k = 1;
            /* while( (k <= n) & (Value <= mvalue(k)) ) */
            while (1)
            {
               B0_ = ( (k <= n) && !mccREL_NAN(n) );
               if ((double)B0_)
               {
                  B0_ = ( (Value_r <= (mccGetRealVectorElement(&mvalue, mccRint(k)))) && !mccREL_NAN(Value_r) && !mccREL_NAN((mccGetRealVectorElement(&mvalue, mccRint(k)))) );
               }
               if (!((double)B0_))
                  break;
               /* k = k+1; */
               k = (k + 1);
               /* end */
            }
            /* if( k <= n ) */
            if (( (k <= n) && !mccREL_NAN(n) ))
            {
               /* for m=n-1:-1:k */
               mccColon(&RM0_, (n - 1), (double) -1, (double)k);
               for (I2_ = 0; I2_ < mccN(&RM0_); ++I2_)
               {
                  m = mccPR(&RM0_)[I2_];
                  /* mvalue(m+1) = mvalue(m); */
                  mccSetVectorElement(&mvalue, mccRint((m + 1)), (mccGetRealVectorElement(&mvalue, mccRint(m))), mccGetImagVectorElement(&mvalue, mccRint(m)));
                  /* y(m+1) = y(m); */
                  mccSetIntVectorElement(&y, mccRint((m + 1)), (double)((int)mccGetRealVectorElement(&y, mccRint(m))));
                  /* x(m+1) = x(m); */
                  mccSetIntVectorElement(&x, mccRint((m + 1)), (double)((int)mccGetRealVectorElement(&x, mccRint(m))));
                  /* end */
               }
               /* mvalue(k) = Value; */
               mccSetVectorElement(&mvalue, mccRint(k), Value_r, Value_i);
               /* y(k) = i; */
               mccSetIntVectorElement(&y, mccRint(k), (double)i);
               /* x(k) = j; */
               mccSetIntVectorElement(&x, mccRint(k), (double)j);
               /* end */
            }
            /* end */
         }
         /* end */
      }
      mccReturnFirstValue(&plhs_[0], &mvalue);
      mccReturnValue(&plhs_[1], &y);
      mccReturnValue(&plhs_[2], &x);
   }
   else
   {
/***************** Compiler Assumptions ****************
 *
 *       B0_         	boolean scalar temporary
 *       Height      	integer scalar
 *       I           	real vector/matrix
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       I2_         	integer scalar temporary
 *       IM0_        	integer vector/matrix temporary
 *       RM0_        	real vector/matrix temporary
 *       Range       	real vector/matrix
 *       Value       	real scalar
 *       Width       	integer scalar
 *       i           	integer scalar
 *       j           	integer scalar
 *       k           	integer scalar
 *       m           	real scalar
 *       maxn        	<function being defined>
 *       mvalue      	real vector/matrix
 *       n           	real scalar
 *       size        	<function>
 *       x           	integer vector/matrix
 *       y           	integer vector/matrix
 *******************************************************/
      mxArray mvalue;
      mxArray y;
      mxArray x;
      mxArray I;
      double n = 0.0;
      int n_set_ = 0;
      mxArray Range;
      int Height = 0;
      int Width = 0;
      int i = 0;
      int j = 0;
      double Value = 0.0;
      int k = 0;
      double m = 0.0;
      mxArray IM0_;
      int I0_ = 0;
      int I1_ = 0;
      unsigned short B0_ = 0;
      int I2_ = 0;
      mxArray RM0_;
      
      mccRealInit(I);
      mccImport(&I, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      n = mccImportReal(&n_set_, 0, (mxArray *) ((nrhs_>1) ? prhs_[1] : 0), 0, "n");
      mccRealInit(Range);
      mccImport(&Range, ((nrhs_>2) ? prhs_[2] : 0), 0, 0);
      mccRealInit(mvalue);
      mccIntInit(y);
      mccIntInit(x);
      mccIntInit(IM0_);
      mccRealInit(RM0_);
      
      /* % MAXN the max n position */
      
      /* [Height, Width] = size(I); */
      if(mccNOTSET(&I))
      {
         mexErrMsgTxt( "variable I undefined, line 4" );
      }
      mccGetMatrixSize(&Height,&Width, &I);
      
      /* mvalue(1:n) = Range(1)-1; */
      if(mccNOTSET(&Range))
      {
         mexErrMsgTxt( "variable Range undefined, line 6" );
      }
      if( !n_set_ )
      {
         mexErrMsgTxt( "variable n undefined, line 6" );
      }
      mccColon2(&IM0_, (double)1, n);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_mvalue;
         int *p_IM0_;
         int I_IM0_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &mvalue);
         mccGrowVector(&mvalue, mccGetMaxIndex(&IM0_ ,mccM(&mvalue)*mccN(&mvalue)));
         I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
         p_IM0_ = mccIPR(&IM0_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_IM0_+=I_IM0_)
               {
                  mccSetRealVectorElement(&mvalue, mccRint(((int)*p_IM0_)), ((mccGetRealVectorElement(&Range, mccRint(1))) - 1));
               }
            }
         }
      }
      mccLOG(&mvalue) = 0;
      mccSTRING(&mvalue) = 0;
      /* y(1:n) = 0; */
      mccColon2(&IM0_, (double)1, n);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         int *p_y;
         int *p_IM0_;
         int I_IM0_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &y);
         mccGrowVector(&y, mccGetMaxIndex(&IM0_ ,mccM(&y)*mccN(&y)));
         I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
         p_IM0_ = mccIPR(&IM0_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_IM0_+=I_IM0_)
               {
                  mccSetIntVectorElement(&y, mccRint(((int)*p_IM0_)), (double)0);
               }
            }
         }
      }
      mccLOG(&y) = 0;
      mccSTRING(&y) = 0;
      /* x(1:n) = 0; */
      mccColon2(&IM0_, (double)1, n);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         int *p_x;
         int *p_IM0_;
         int I_IM0_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &x);
         mccGrowVector(&x, mccGetMaxIndex(&IM0_ ,mccM(&x)*mccN(&x)));
         I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
         p_IM0_ = mccIPR(&IM0_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_IM0_+=I_IM0_)
               {
                  mccSetIntVectorElement(&x, mccRint(((int)*p_IM0_)), (double)0);
               }
            }
         }
      }
      mccLOG(&x) = 0;
      mccSTRING(&x) = 0;
      
      /* for i=1:Height */
      for (I0_ = 1; I0_ <= Height; I0_ = I0_ + 1)
      {
         i = I0_;
         /* for j=1:Width */
         for (I1_ = 1; I1_ <= Width; I1_ = I1_ + 1)
         {
            j = I1_;
            /* Value = I(i,j); */
            Value = (mccGetRealMatrixElement(&I, mccRint(i), mccRint(j)));
            /* k = 1; */
            k = 1;
            /* while( (k <= n) & (Value <= mvalue(k)) ) */
            while (1)
            {
               B0_ = ( (k <= n) && !mccREL_NAN(n) );
               if ((double)B0_)
               {
                  B0_ = ( (Value <= (mccGetRealVectorElement(&mvalue, mccRint(k)))) && !mccREL_NAN(Value) && !mccREL_NAN((mccGetRealVectorElement(&mvalue, mccRint(k)))) );
               }
               if (!((double)B0_))
                  break;
               /* k = k+1; */
               k = (k + 1);
               /* end */
            }
            /* if( k <= n ) */
            if (( (k <= n) && !mccREL_NAN(n) ))
            {
               /* for m=n-1:-1:k */
               mccColon(&RM0_, (n - 1), (double) -1, (double)k);
               for (I2_ = 0; I2_ < mccN(&RM0_); ++I2_)
               {
                  m = mccPR(&RM0_)[I2_];
                  /* mvalue(m+1) = mvalue(m); */
                  mccSetRealVectorElement(&mvalue, mccRint((m + 1)), (mccGetRealVectorElement(&mvalue, mccRint(m))));
                  /* y(m+1) = y(m); */
                  mccSetIntVectorElement(&y, mccRint((m + 1)), (double)((int)mccGetRealVectorElement(&y, mccRint(m))));
                  /* x(m+1) = x(m); */
                  mccSetIntVectorElement(&x, mccRint((m + 1)), (double)((int)mccGetRealVectorElement(&x, mccRint(m))));
                  /* end */
               }
               /* mvalue(k) = Value; */
               mccSetRealVectorElement(&mvalue, mccRint(k), Value);
               /* y(k) = i; */
               mccSetIntVectorElement(&y, mccRint(k), (double)i);
               /* x(k) = j; */
               mccSetIntVectorElement(&x, mccRint(k), (double)j);
               /* end */
            }
            /* end */
         }
         /* end */
      }
      mccReturnFirstValue(&plhs_[0], &mvalue);
      mccReturnValue(&plhs_[1], &y);
      mccReturnValue(&plhs_[2], &x);
   }
   return;
}
